<?php
// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

oc_checkField('title', $GLOBALS['OC_submissionFieldAR'], $qfields, $err);

oc_checkField('student', $GLOBALS['OC_submissionFieldAR'], $qfields, $err, true);

// Check authors 
$firstBlankAuthor = 0;
$lastAuthor = 0;
for ($a=1; $a<=$OC_configAR['OC_authorsMax']; $a++) {
	if (!isset($_POST['name_last' . $a]) || empty($_POST['name_last' . $a])) {
		if ($firstBlankAuthor == 0) { 
			$firstBlankAuthor = $a;
		}
		if ((isset($_POST['name_first' . $a]) && !empty($_POST['name_first' . $a])) 
				|| (isset($_POST['organization' . $a]) && !empty($_POST['organization' . $a])) 
				|| (isset($_POST['country' . $a]) && !empty($_POST['country' . $a])) 
				|| (isset($_POST['email' . $a]) && !empty($_POST['email' . $a]))
		) {
			$err .= '<li>' . sprintf(oc_('Author %d missing last name'), $a) . '</li>';	
		} 
	} else {
		$afields[$a] = array('name_last' => "'" . safeSQLstr(varValue('name_last' . $a, $_POST)) . "'");

		oc_checkAuthorField('honorific', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('name_first', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('suffix', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('organization', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('address', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('address2', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('city', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('spc', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('postcode', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err);
		oc_checkAuthorField('country', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err, true);
		oc_checkAuthorField('email', $a, $GLOBALS['OC_submissionFieldAR'], $afields, $err, true);

		$lastAuthor = $a;
	}
	 
}
if ($lastAuthor == 0) {	// no author info
	$err .= '<li>' . oc_('Authors information missing.') . '</li>';
} elseif (($firstBlankAuthor > 0) && ($firstBlankAuthor < $lastAuthor)) {	// blank author - can't skip otherwise ordering will be messed up
	$err .= '<li>' . oc_('One or more author\'s data skipped.  Please enter authors sequentially.') . '</li>';
} elseif (!preg_match("/^\d+/", $_POST['contactid']) || ($_POST['contactid'] < 1) || ($_POST['contactid'] > $OC_configAR['OC_authorsMax'])) {  // Check that we have a valid contact author & email
	$err .= '<li>' . oc_('Contact author invalid') . '</li>';
} else {
	$contactemail = $_POST['email' . $_POST['contactid']];
	if (!validEmail($contactemail)) {
		$err .= '<li>' . oc_('Contact author email does not seem valid') . '</li>';
	} else {
		$qfields['contactid'] = safeSQLstr($_POST['contactid']);
	}
}

oc_checkField('altcontact', $GLOBALS['OC_submissionFieldAR'], $qfields, $err);

// Check other authors
if (isset($OC_submissionFieldAR['otherauthors']) && oc_fieldEnabled('otherauthors', $GLOBALS['OC_submissionFieldAR']) && isset($_POST['otherauthors'])) {
	$qfields['otherauthors'] =  "'" . safeSQLstr(varValue('otherauthors', $_POST)) . "'";				
}

// Check topics
if (isset($OC_submissionFieldAR['topics']) && oc_fieldEnabled('topics', $GLOBALS['OC_submissionFieldAR'])) {
	if (!isset($_POST['topics']) || empty($_POST['topics'])) {
		$err .= '<li>' . sprintf('%s field is required', $GLOBALS['OC_submissionFieldAR']['topics']['short']) . '</li>';
	} else {
		if (is_array($_POST['topics'])) {
			foreach ($_POST['topics'] as $tid) {
				if ( !ctype_digit($tid) || !isset($topicAR[$tid]) ) {
					//T: %1$s = topic field short name; %2$s = invalid field value
					$err .= '<li>' . sprintf(oc_('%1$s field value is invalid: %2$s'), $GLOBALS['OC_submissionFieldAR']['topics']['short'], safeHTMLstr($tid)) . '</li>';
				} else {
					$tfields[] = $tid;
				}
			}
		} else {
			if ( !ctype_digit($_POST['topics']) || !isset($topicAR[$_POST['topics']]) ) {
					//T: %1$s = topic field short name; %2$s = invalid field value
				$err .= '<li>' . sprintf(oc_('%1$s field value is invalid: %2$s'), $GLOBALS['OC_submissionFieldAR']['topics']['short'], safeHTMLstr($_POST['topics'])) . '</li>';
			} else {
				$tfields[] = $_POST['topics'];
			}
		}
	}
}

// Check keywords
oc_checkField('keywords', $GLOBALS['OC_submissionFieldAR'], $qfields, $err);

// Check abstract
// We're not using str_word_count as numbers are not counted.
if (isset($OC_submissionFieldAR['abstract']) && oc_fieldEnabled('abstract', $GLOBALS['OC_submissionFieldAR'])) {
	if (isset($_POST['abstract']) && !empty($_POST['abstract'])) {
		if (isset($OC_configAR['OC_abstractLength']) && ($OC_configAR['OC_abstractLength'] > 0)) {
			$oc_abstractLength = count(explode(' ', preg_replace("/\s+/", " ", trim($_POST['abstract']))));
			if ($oc_abstractLength > $OC_configAR['OC_abstractLength']) {
			  $err .= '<li>' . sprintf(oc_('%1$s field contains %2$d words; limit is %3$d words.'), oc_($GLOBALS['OC_submissionFieldAR']['abstract']['short']), $oc_abstractLength, $OC_configAR['OC_abstractLength']) . '</li>';
			}
		}
		$qfields['abstract'] = "'" . safeSQLstr(varValue('abstract', $_POST)) . "'";				
	} elseif ( $GLOBALS['OC_submissionFieldAR']['abstract']['required'] ) {
		$err .= '<li>' . sprintf(oc_('%s field is required'), oc_($GLOBALS['OC_submissionFieldAR']['abstract']['short'])) . '</li>';
	} else {
		$qfields['abstract'] =  "''";				
	}
}

// Check file?
if ($OC_configAR['OC_includeSubmissionUploadField'] && isset($OC_submissionFieldAR['file'])) {
	if ( isset($_FILES['file']['error'])
		&& ($_FILES['file']['error'] == UPLOAD_ERR_OK) 
		&& is_uploaded_file($_FILES['file']['tmp_name'])
		&& ($_FILES['file']['size'] > 0)
	) { // file uploaded ok
		if ( ! isset($_POST['format']) || ! in_array($_POST['format'], $extAR) ) { // invalid format
			$err .= '<li>' . oc_('File format invalid') . '</li>';
		} else {  // upload good
			$fileUploaded = true;
			if (oc_hookSet('author-file-validate')) {
				foreach ($GLOBALS['OC_hooksAR']['author-file-validate'] as $hook) {
					require_once $hook;
				}
			}
			if ($fileUploaded) {
				$errInc .= '<br /><li>' . oc_('Also, re-select the file') . '</li>';  // let user know file must be re-selected if there was another error
			}
		}
	} elseif ( isset($_FILES['file']['error']) ) { // notify of error
		switch($_FILES['file']['error']) {
			case UPLOAD_ERR_INI_SIZE:
			case UPLOAD_ERR_FORM_SIZE:
				$err .= '<li>' . oc_('File size too large') . '</li>';
				break;
			case UPLOAD_ERR_NO_FILE:
				if ($OC_configAR['OC_requireSubmissionUploadField']) {  // file required? if not, no error
					$err .= '<li>' . oc_('File missing') . '</li>';
				}
				break;
			default:
				$err .= '<li>' . oc_('File did not upload properly') . '</li>';
				break;
		} 
	} elseif ($OC_configAR['OC_requireSubmissionUploadField']) { // catch all for file required?
		$err .= '<li>' . oc_('File missing') . '</li>';
	}
}

// Check comments
oc_checkField('comments', $GLOBALS['OC_submissionFieldAR'], $qfields, $err);

// Check password if either field is not empty or it's an original submission
if ( (isset($_POST['password1']) && !empty($_POST['password1']))
		|| (isset($_POST['password2']) && !empty($_POST['password2'])) 
		|| ( ! isset($_POST['pid']) )
) {
	if (!isset($_POST['password1']) || !isset($_POST['password2']) || empty($_POST['password1'])) {
		$err .= '<li>' . oc_('Password must be entered twice') . '</li>';
	} elseif ($_POST['password1'] != $_POST['password2']) {
		$err .= '<li>' . oc_('Passwords entered do not match') . '</li>';
	} else {
		$qfields['password'] = "'" . hashPassword($_POST['password1']) . "'";
	}
}

if (oc_hookSet('author-submission-validate')) {
	foreach ($GLOBALS['OC_hooksAR']['author-submission-validate'] as $hook) {
		require_once $hook;
	}
}
