<?php 

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("Assign Advocates", 1);


if (isset($_POST['submit']) && ($_POST['submit'] == "Assign Advocates")) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
    // Check that we have at least one paper and advocate
    if (empty($_POST['papers']) || empty($_POST['advocates'])) {
        print '<span class="err">Please go back and select at least one submission and one advocate</span><p>';
    } else {
		// Get conflicts?
		if ($OC_configAR['OC_allowConflictOverride'] && isset($_POST['conflict_override']) && ($_POST['conflict_override'] == 1)) {
			$conflictAR = array();
		} else {
			$conflictAR = getConflicts();
		}
		// Assign advocates (and reviewers?)
		// NOTE: Although a foreach is used below for future expansion, there should only be 1 advocate
		$advocateAssignmentAR = array();    // keep track of advocates w/successful assignments
		foreach ($_POST['advocates'] as $i) {
			if (!is_numeric($i)) { err('Invalid advocate ID: ' . safeHTMLstr($i)); }
			$count = 0; // keep track of # of successful assignments
			foreach ($_POST['papers'] as $j) {
				if (!is_numeric($j)) { err('Invalid submission ID: ' . safeHTMLstr($j)); }
				// Check for conflict
				if (in_array("$j-$i",$conflictAR)) {
					print "<p class=\"warn\">! Submission $j is in conflict with advocate $i.</p>\n";
					continue;
				}
				// Delete current assignment?
				if (isset($_POST['assignment_override']) && ($_POST['assignment_override'] == 1)) {
					issueSQL("DELETE FROM " . OCC_TABLE_PAPERADVOCATE . " WHERE paperid=" . $j);
				}
				// Make assignment
				$q = "INSERT INTO " . OCC_TABLE_PAPERADVOCATE . " (paperid,advocateid) VALUES ($j,$i)";
				ocsql_query($q);
				if (($merr = mysql_errno()) != 0) {
					if ($merr == 1062) {	// Duplicate entry
					    print "<span class=\"warn\">! Submission $j already has an advocate assigned.  Please delete the existing advocate first before assigning a new one, or select <em>Override Current Assingment</em>.</span><p />\n";
					} else {
	                    print "<span class=\"err\">!! Error assigning submission $j to advocate $i (" . mysql_error() . ")</span><p />\n";
					}
                } else {
                    print "<p>Submission $j assigned to advocate $i.\n";
                    $count++;
					// Also assign a reviewer?
					if (isset($_POST['asrev']) && ($_POST['asrev'] == "yes")) {
						$q = "INSERT INTO " . OCC_TABLE_PAPERREVIEWER . " (paperid,reviewerid) VALUES ($j,$i)";
						ocsql_query($q);
        	        	if (($merr = mysql_errno()) != 0) {
							if ($merr == 1062) {	// Duplicate entry
							    print "<dd><span class=\"warn\">! Submission $j has already been assigned reviewer $i.</span></dd><p />\n";
							} else {
	            	    	    print "<span class=\"err\">!! Error assigning submission $j to reviewer $i (" . mysql_error() . ")</span><p />\n";
							}
						}
					}
                } 
            } 
            if ($count > 0) { $advocateAssignmentAR[] = $i; }
        } 
        // Notify?
		if (isset($_POST['notify']) && ($_POST['notify'] == 1) && !empty($advocateAssignmentAR)) {
			$q = "SELECT reviewerid, CONCAT_WS(' ',name_first,name_last) AS name, email FROM " . OCC_TABLE_REVIEWER . " WHERE reviewerid IN (" . implode(',',$advocateAssignmentAR) . ")";
			$r = ocsql_query($q) or err('Unable not get advocate email address(es) for notification ' . mysql_errno());
			$msg = sprintf(oc_('New assignments have been made for you to advocate in the %s OpenConf system.'), $OC_configAR['OC_confNameFull']) . "\n\n" . oc_('Thank you.') . "\n";
			while ($l = mysql_fetch_array($r)) {
				if (sendEmail($l['email'], oc_('New Advocate Assignment(s)'), $msg)) {
					print '<p>Notification sent to ' . $l['name'] . ' (' . $l['reviewerid'] . ')</p>';
				} else {
					print '<p class="err">!! Unable to email notification to <a href="mailto:' . safeHTMLstr($l['email']) . '">' . $l['name'] . '</a> (' . $l['reviewerid'] . ')</p>';
				}
			}
		}
    } 
} else {
    $pq = "SELECT " . OCC_TABLE_PAPER . ".paperid, " . OCC_TABLE_PAPER . ".title, " . OCC_TABLE_PAPERADVOCATE . ".advocateid FROM " . OCC_TABLE_PAPER . " LEFT JOIN " . OCC_TABLE_PAPERADVOCATE . " ON " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_PAPERADVOCATE . ".paperid ORDER  BY " . OCC_TABLE_PAPER . ".paperid";
    $pr = ocsql_query($pq) or err("Unable to get submissions");
	// Get pad size for paper id's - yes, we really need the max id, but this should do:)
	$psize = oc_strlen((string) mysql_num_rows($pr));
    if (mysql_num_rows($pr) == 0) {
        print '<span class="warn">No submissions have been made yet</span><p>';
    } else {
		if (!isset($_GET['s']) || ($_GET['s'] == "id"))  {
			$idsortstr = 'ID';
		    $nsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=name">Name</a>';
			$rsortstr = '# <a href="' . $_SERVER['PHP_SELF'].'?s=reviews">Submission</a>';
			$legend = "[ Advocate ID - $nsortstr ($rsortstr) ]";
			$sortby = OCC_TABLE_REVIEWER . ".reviewerid";
		} elseif ($_GET['s'] == "reviews") {
			$rsortstr = '# Reviews';
		    $idsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=id">ID</a>';
		    $nsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=name">Name</a>';
			$legend = "[ # Submissions - Advocate $nsortstr - $idsortstr ]";
			$sortby = "acount, " . OCC_TABLE_REVIEWER . ".name_last, " . OCC_TABLE_REVIEWER . ".name_first";
		} else {
		    $idsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=id">ID</a>';
			$nsortstr = 'Name';
			$rsortstr = '# <a href="' . $_SERVER['PHP_SELF'].'?s=reviews">Submissions</a>';
			$legend = "[ Advocate Name - $idsortstr ($rsortstr) ]";
			$sortby = OCC_TABLE_REVIEWER . ".name_last, " . OCC_TABLE_REVIEWER . ".name_first";
		}
		$rq = "SELECT " . OCC_TABLE_REVIEWER . ".reviewerid, CONCAT_WS(' '," . OCC_TABLE_REVIEWER . ".name_first," . OCC_TABLE_REVIEWER . ".name_last) AS name, count(" . OCC_TABLE_PAPERADVOCATE . ".advocateid) AS acount FROM " . OCC_TABLE_REVIEWER . " LEFT JOIN " . OCC_TABLE_PAPERADVOCATE . " ON " . OCC_TABLE_REVIEWER . ".reviewerid=" . OCC_TABLE_PAPERADVOCATE . ".advocateid WHERE " . OCC_TABLE_REVIEWER . ".onprogramcommittee='T' GROUP BY " . OCC_TABLE_REVIEWER . ".reviewerid ORDER BY $sortby";
        $rr = ocsql_query($rq) or err("Unable to get program committee members");
		// Get pad size for advocate id's - yes, we really need the max id, but this should do:)
		$rsize = oc_strlen((string) mysql_num_rows($rr));
        if (mysql_num_rows($rr) == 0) {
            print '<span class="warn">No program committee members have signed up yet</span><p>';
        } else {
            print '
  <form method="post" action="' . $_SERVER['PHP_SELF'] . '">
  <input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
  <dl>
  <dt><strong>Select Submission(s):</strong></dt>
  <dd><p>[ Submission ID - Title (Advocate ID or ***) ]</p></dd>
  <dd><select multiple size=10 name="papers[]">
      ';

            while ($paper = mysql_fetch_array($pr)) {
                print '<option value="' . $paper['paperid'] . '">' . padNumber($paper['paperid'],$psize) . ' - ' . safeHTMLstr(shortenStr($paper['title'],80)) . ' (';
		if ($paper['advocateid']) { print $paper['advocateid']; }
		else { print '***'; }
		print ")</option>\n";
            } 

            print '
  </select>
  <p /></dd>
  <dt><p><strong>Select Advocate:</strong> &nbsp; <span class="note">(You may only assign one advocate per submission)</span><p /></dt>
  <dd><span class="note">Tip: Click on ID, Name, or Submissions on the line below to re-sort this list (page will reload)</span><p /></dd>
  <dd><p>' . $legend . '</p></dd>
  <dd><p><select size=10 name="advocates[]">
      ';

            while ($advocate = mysql_fetch_array($rr)) {
                print '<option value="' . $advocate['reviewerid'] . '">';
				if (!isset($_GET['s']) || ($_GET['s'] == "id")) {
					print padNumber($advocate['reviewerid'],$rsize) . ' - ' . safeHTMLstr($advocate['name']) . " (" . $advocate['acount'] . ")</option>\n";
				} elseif ($_GET['s'] == "reviews") {
					print padNumber($advocate['acount'],2) . ' - ' . safeHTMLstr($advocate['name']) . " - " . $advocate['reviewerid'] . "</option>\n";
				} else {
					print safeHTMLstr($advocate['name']) . " - " . $advocate['reviewerid'] . " (" . $advocate['acount'] . ")</option>\n";
				}
            } 

            print '
  </select></p></dd>
  <dt><p><strong>Options:</strong></p></dt>
  <dd><p><input type="checkbox" name="asrev" value="yes"> <strong><em>Assign as Reviewer</em></strong> &#8211; check box to also assign advocate as reviewer of submission</p></dd>
  <dd><p><input type="checkbox" name="assignment_override" value="1"> <strong><em>Override Current Assignment</em></strong> &#8211; check box to change advocate if one already assigned</p></dd>
';
			if ($OC_configAR['OC_allowConflictOverride']) {
				print '<dd><p><input type="checkbox" name="conflict_override" value="1" /> <strong><em>Override Conflicts</em></strong> &#8211; check box to make assignments even if there is a conflict</p></dd>';
			}
			print '
  <dd><p><input type="checkbox" name="notify" value="1"> <strong><em>Notify Advocate(s)</em></strong> &#8211; check box to notify advocate(s) that new assignments have been made</p></dd>
  <dt><p><input type="submit" name="submit" value="Assign Advocates"></p></dt>
  </dl>
  </form><p />
      ';
        } 
    } 
} 

printFooter();

?>
