<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("Assign Reviews",1);

if (isset($_POST['submit']) && ($_POST['submit'] == "Assign Reviews")) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
	// Check that we have at least one paper and reviewer
	if (empty($_POST['papers']) || empty($_POST['reviewers'])) {
		print '<span class="err">Please go back and select at least one submission and one reviewer</span><p>';
	} else {
		// Get conflicts?
		if ($OC_configAR['OC_allowConflictOverride'] && isset($_POST['conflict_override']) && ($_POST['conflict_override'] == 1)) {
			$conflictAR = array();
		} else {
			$conflictAR = getConflicts();
		}
		// Assign reviews
		$reviewerAssignmentAR = array();    // keep track of reviewers w/successful assignments
		foreach ($_POST['reviewers'] as $i) {
			// valid rev id?
			if (!preg_match("/^\d+$/", $i)) {
				err('Invalid reviewer selected');
			}
			// iterate through submissions for reviewers
			foreach ($_POST['papers'] as $j) {
				// valid sub id?
				if (!preg_match("/^\d+$/", $j)) {
					err('Invalid submission selected');
				}
				// Check for conflict
				if (in_array("$j-$i",$conflictAR)) {
					print "<p class=\"warn\">! Submission $j is in conflict with reviewer $i.</p>\n";
					continue;
				}
				// Make assignment
				$q = "INSERT INTO `" . OCC_TABLE_PAPERREVIEWER . "` (`paperid`,`reviewerid`) VALUES ($j,$i)";
				ocsql_query($q);
                if (($merr = mysql_errno()) != 0) {
					if ($merr == 1062) {	// Duplicate entry
					    print "<p class=\"warn\">! Submission $j was already assigned reviewer $i.</p>\n";
					} else {
	                    print "<p class=\"err\">!! Error assigning submission $j to reviewer $i (" . mysql_error() . ")</p>\n";
					}
				} else {
		  			print "<p>Submission $j assigned to reviewer $i.</p>\n";
		  			if (!in_array($i,$reviewerAssignmentAR)) {
						$reviewerAssignmentAR[] = $i;
					}

					// Hook
					if (oc_hookSet('chair-assign-review')) {
						foreach ($OC_hooksAR['chair-assign-review'] as $f) {
							require_once $f;
						}
					}

	  			}
			}
		}
		// Notify?
		if (isset($_POST['notify']) && ($_POST['notify'] == 1) && !empty($reviewerAssignmentAR)) {
			$q = "SELECT reviewerid, CONCAT_WS(' ',name_first,name_last) AS name, email FROM " . OCC_TABLE_REVIEWER . " WHERE reviewerid IN (" . implode(',',$reviewerAssignmentAR) . ")";
			$r = ocsql_query($q) or err('Unable not get reviewer email address(es) for notification ' . mysql_errno());
			$msg = sprintf(oc_('New assignments have been made for you to review in the %s OpenConf system.'), $OC_configAR['OC_confNameFull']) . "\n\n" . oc_('Thank you.') . "\n";
			while ($l = mysql_fetch_array($r)) {
				if (sendEmail($l['email'], oc_('New Reviewer Assignment(s)'), $msg)) {
					print '<p>Notification sent to ' . $l['name'] . ' (' . $l['reviewerid'] . ')</p>';
				} else {
					print '<p class="err">!! Unable to email notification to <a href="mailto:' . safeHTMLstr($l['email']) . '">' . $l['name'] . '</a> (' . $l['reviewerid'] . ')</p>';
				}
			}
		}
	}
} else {
	$pq = "SELECT " . OCC_TABLE_PAPER . ".paperid, " . OCC_TABLE_PAPER . ".title, count(" . OCC_TABLE_PAPERREVIEWER . ".paperid) AS pcount FROM " . OCC_TABLE_PAPER . " LEFT JOIN " . OCC_TABLE_PAPERREVIEWER . " ON " . OCC_TABLE_PAPER . ".paperid=" . OCC_TABLE_PAPERREVIEWER . ".paperid GROUP BY " . OCC_TABLE_PAPER . ".paperid ORDER BY " . OCC_TABLE_PAPER . ".paperid";
	$pr = ocsql_query($pq) or err("Unable to get submissions");
	// Get pad size for paper id's - yes, we really need the max id, but this should do:)
    $rows = mysql_num_rows($pr);
	$psize = oc_strlen((string) $rows);
	if ($rows == 0) {
		print '<span class="warn">No submissions have been made yet</span><p>';
	}
	else {
		if (!isset($_GET['s']) || ($_GET['s'] == "id"))  {
			$idsortstr = 'ID';
		    $nsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=name">Name</a>';
			$rsortstr = '# <a href="' . $_SERVER['PHP_SELF'].'?s=reviews">Reviews</a>';
			$legend = "[ Reviewer ID - $nsortstr ($rsortstr) ]";
			$sortby = OCC_TABLE_REVIEWER . ".reviewerid";
		} elseif ($_GET['s'] == "reviews") {
			$rsortstr = '# Reviews';
		    $idsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=id">ID</a>';
		    $nsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=name">Name</a>';
			$legend = "[ # Reviews - Reviewer $nsortstr - $idsortstr ]";
			$sortby = "rcount, " . OCC_TABLE_REVIEWER . ".name_last, " . OCC_TABLE_REVIEWER . ".name_first";
		} else {
		    $idsortstr = '<a href="' . $_SERVER['PHP_SELF'].'?s=id">ID</a>';
			$nsortstr = 'Name';
			$rsortstr = '# <a href="' . $_SERVER['PHP_SELF'].'?s=reviews">Reviews</a>';
			$legend = "[ Reviewer Name - $idsortstr ($rsortstr) ]";
			$sortby = OCC_TABLE_REVIEWER . ".name_last, " . OCC_TABLE_REVIEWER . ".name_first";
		}
		$rq = "SELECT " . OCC_TABLE_REVIEWER . ".reviewerid, onprogramcommittee, CONCAT_WS(' '," . OCC_TABLE_REVIEWER . ".name_first," . OCC_TABLE_REVIEWER . ".name_last) AS name, COUNT(" . OCC_TABLE_PAPERREVIEWER . ".reviewerid) AS rcount FROM " . OCC_TABLE_REVIEWER . " LEFT JOIN " . OCC_TABLE_PAPERREVIEWER . " ON " . OCC_TABLE_REVIEWER . ".reviewerid=" . OCC_TABLE_PAPERREVIEWER . ".reviewerid GROUP BY " . OCC_TABLE_REVIEWER . ".reviewerid ORDER BY $sortby";
		$rr = ocsql_query($rq) or err("Unable to get reviewers");
		// Get pad size for reviewer id's - yes, we really need the max id, but this should do:)
		$rsize = oc_strlen((string) mysql_num_rows($rr));
		if (mysql_num_rows($rr) == 0) {
			print '<span class="warn">No reviewers have signed up yet</span><p>';
		}
		else {
			print '
  <form method="post" action="'.$_SERVER['PHP_SELF'].'">
  <input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
  <dl>
  <dt><p><strong>Select Submission(s):</strong></p></dt>
  <dd><p>[ Submission ID - Title (# Reviewers) ]</p></dd>
  <dd><select multiple size=10 name="papers[]">
			';
  
			while ($paper = mysql_fetch_array($pr)) {
				print '<option value="'.$paper['paperid'].'">' . padNumber($paper['paperid'],$psize) . ' - ' . safeHTMLstr(shortenStr($paper['title'],80)) . " (" . $paper['pcount'] . ")</option>\n";
			}
  
			print '
  </select>
  <p /></dd>
  <dt><p><strong>Select Reviewer(s):</strong></p></dt>
  <dd><p><span class="note">Tip: Click on ID, Name, or Reviews on the line below to re-sort this list (page will reload)</span></p></dd>
  <dd><p>' . $legend . '</p></dd>
  <dd><select multiple size=10 name="reviewers[]">
			';
  
			while ($reviewer = mysql_fetch_array($rr)) {
				print '<option value="'.$reviewer['reviewerid'].'">';
				if (!isset($_GET['s']) || ($_GET['s'] == "id")) {
					print padNumber($reviewer['reviewerid'],$rsize) . ' - ';
					if ($reviewer['onprogramcommittee'] == 'T') {
					    print "[PC] ";
					}
					print safeHTMLstr($reviewer['name']) . " (" . $reviewer['rcount'] . ")</option>\n";
				} elseif ($_GET['s'] == "reviews") {
					print padNumber($reviewer['rcount'],2) . ' - ';
					if ($reviewer['onprogramcommittee'] == 'T') {
					    print "[PC] ";
					}
					print safeHTMLstr($reviewer['name']) . " - " . $reviewer['reviewerid'];
				} else {
					if ($reviewer['onprogramcommittee'] == 'T') {
					    print "[PC] ";
					}
					print safeHTMLstr($reviewer['name']) . " - " . $reviewer['reviewerid'] . " (" . $reviewer['rcount'] . ")</option>\n";
				}
			}

			print '
  </select>
  <p /></dd>
  <dt><p><strong>Options:</strong></p></dt>
';
			if ($OC_configAR['OC_allowConflictOverride']) {
		 		print '
  <dd><p><input type="checkbox" name="conflict_override" value="1" /> <strong><em>Override Conflicts</em></strong> &#8211; check box to force assignments even if there is a conflict</p></dd>
';
			}
			print '
  <dd><p><input type="checkbox" name="notify" value="1"> <strong><em>Notify Reviewer(s)</em></strong> &#8211; check box to notify reviewer(s) that new assignments have been made</p></dd>
  <dt><p><input type="submit" name="submit" value="Assign Reviews" /></p></dt>
  </dl>
  </form><p>
			';
		}
	}
}

printFooter();

?>
