<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

function oc_export(&$scope, &$exportFieldsAR, &$fieldNameAR, &$dbR, &$extraAR=array(), &$fieldAR=array()) {

	$exportFormatAR = array(
		'csv' => 'text/plain',
		'txt' => 'text/plain',
		'xls' => 'application/vnd.ms-excel',
		'xml' => 'application/xml'
	);
	
	if (isset($_POST['format']) && isset($exportFormatAR[$_POST['format']])) {
		$format = $_POST['format'];
	} else {
		$format = 'csv';
	}
	
	// set filename
	$fileName = 'openconf';
	if (preg_match("/^\w+$/", $GLOBALS['OC_configAR']['OC_confName'])) {
		$fileName .= '-' . $GLOBALS['OC_configAR']['OC_confName'];
	}
	$fileName .= '-' . oc_strtolower($scope) . '-' . date('YmdHi') . '.' . $format;
	
	// send out headers
	oc_sendNoCacheHeaders();
	header('Content-Type: ' . $exportFormatAR[$format]);
	header('Content-Disposition: attachment; filename="' . $fileName . '"');
	
	// export file
	switch ($format) {
	
		case 'xls':	// *****************************************************************
		
			print '<html xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:x="urn:schemas-microsoft-com:office:excel"
	xmlns="http://www.w3.org/TR/REC-html40">
	
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html>
	<head>
		<meta http-equiv="Content-type" content="text/html;charset=utf-8" />
	<style id="Classeur1_16681_Styles">
	</style>
	
	</head>
	<body>
	
	<div id="Classeur1_16681" align=center x:publishsource="Excel">
	
	<table x:str border=0 cellpadding=0 cellspacing=0 width=100% style="border-collapse: collapse">
	';
			// Title Row
			print '<tr>';
			foreach ($exportFieldsAR as $f) {
				print '<td class=xl2216681 nowrap><strong>' . (isset($fieldNameAR[$f]) ? $fieldNameAR[$f] : ucwords(preg_replace("/_/", " ", trim($f, "_")))) . '</strong></td>';
			}
			print '</tr>';
			
			// Iterate through records
			while ($l = mysql_fetch_array($dbR)) {
				print '<tr>';
				foreach ($exportFieldsAR as $f) {
					if (preg_match("/^_/", $f)) {  
						if (isset($extraAR[$l['id']][$f])) {
							$val = $extraAR[$l['id']][$f];
						} else {
							$val ='';
						}
					} else {
						$val = oc_getFieldValue($fieldAR, $l, $f);
					}
					print '<td class=xl2216681 nowrap>' . htmlspecialchars($val) . '</td>';
				}
				print '</tr>';		
			}
			print '
	</table>
	</div>
	</body>
	</html>
	';
	
			break;
			
		case 'xml':	// *****************************************************************
		
			print '<?xml version="1.0" encoding="utf-8" ?>
	<!--
	-
	- OpenConf Export: ' . $scope . '
	-
	- Version: ' . $GLOBALS['OC_configAR']['OC_version'] . '
	- Created: ' . date('Y-m-d H:i:s') . '
	-
	-->
	<openconf>		
	';
	
			// Iterate through records
			while ($l = mysql_fetch_array($dbR)) {
				print "	<entry>\n";
				foreach ($exportFieldsAR as $f) {
					$tag = (isset($fieldNameAR[$f]) ? $fieldNameAR[$f] : ucwords(preg_replace("/_/", " ", trim($f, "_"))));
					$tag = preg_replace("/[^\w]/", "", $tag);
					if (preg_match("/^_/", $f)) {  
						if (isset($extraAR[$l['id']][$f])) {
							$val = $extraAR[$l['id']][$f];
						} else {
							$val ='';
						}
					} else {
						$val = oc_getFieldValue($fieldAR, $l, $f);
					}
					if ($val == '') {
						print "		<$tag />\n";
					} else {
						print "		<$tag>" . htmlspecialchars($val) . "</$tag>\n";
					}
				}
				print "	</entry>\n";
			}
	
			print '</openconf>';
		
			break;
			
		default:	// *****************************************************************
		
			if ($format == 'txt') {
				$delim = "\t";
			} else {
				$delim = ',';
			}
			
			// Title Row
			$titlerow = '';
			foreach ($exportFieldsAR as $f) {
				$titlerow .= '"' . (isset($fieldNameAR[$f]) ? $fieldNameAR[$f] : preg_replace("/_/", " ", trim($f, "_"))) . '"' . $delim;
			}
			print oc_strtoupper(rtrim($titlerow, $delim)) . "\r\n";
			
			// Iterate through records
			while ($l = mysql_fetch_array($dbR)) {
				$row = '';
				// Add non-author/extra fields to row
				foreach ($exportFieldsAR as $f) {
					if (preg_match("/^_/", $f)) {
						$row .= '"' . (isset($extraAR[$l['id']][$f]) ? str_replace("\"", "\"\"", $extraAR[$l['id']][$f]) : '') . '"' . $delim;
					} else {
						$row .= '"' . str_replace("\"", "\"\"", oc_getFieldValue($fieldAR, $l, $f)) . '"' . $delim;
					}
				}
			
				$row = preg_replace("/\015(\012)?/", "\012", $row);
				print rtrim($row, $delim) . "\015\012";
			}
	
			break;
			
	}
	
	// exit so not additional code is executed
	exit;
} // oc_export f'n