<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

$hdr = '';
$hdrfn = 1;

require_once '../include.php';
require_once OCC_ZONE_FILE;

$OC_extraHeaderAR[] = '
<script language="javascript" type="text/javascript">
<!--
function oc_showHideDiv(fldName, divID) {
	if (document.getElementById) {
		if (document.getElementById(fldName).checked) {
			document.getElementById(divID).style.display="block";
		} else {
			document.getElementById(divID).style.display="none";
		}
	}
}
// -->
</script>
';

if (!OCC_INSTALL_COMPLETE && isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	require_once "install-include.php";
	$token = '';
} else {
	beginChairSession();
	printHeader("Configuration", 1);
	$token = $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'];
	// Display active modules config
	if (isset($OC_activeModulesAR) && !empty($OC_activeModulesAR)) {
		$moduleOptions = '';
		foreach ($OC_activeModulesAR as $module) {
			if (is_file('../modules/' . $module . '/settings.inc')) {
				$moduleOptions .= '<option value="' . $module . '">' . safeHTMLstr($OC_modulesAR[$module]['name']) . '</option>';
			}
		}
		if (!empty($moduleOptions)) {
			print '
<form method="get" action="../modules/request.php">
<p style="text-align: center">
<input type="hidden" name="action" value="settings.inc" />
Config Module: <select name="module">
<option value=""></option>
' . $moduleOptions . '
</select>
<input type="submit" value="Go" />
</p>
</form>
';
		}
	}
}

// YesNo fields
$yesNoFieldsAR = array('OC_includeSubmissionUploadLink', 'OC_trackStudent', 'OC_notifyIncludeIP', 'OC_reviewerReadPapers', 'OC_reviewerSeeAssignedReviews', 'OC_reviewerCompleteBeforeSAR', 'OC_reviewerSeeOtherReviews', 'OC_reviewerSeeOtherReviewers', 'OC_reviewerSeeAuthors', 'OC_advocateReadPapers', 'OC_advocateSeeOtherReviews', 'OC_advocateSeeAuthors', 'OC_paperAdvocates');
if ( ! oc_moduleActive('oc_aws') ) { // submission form file upload is not compatible with AWS
	$yesNoFieldsAR[] = 'OC_includeSubmissionUploadField';
	$yesNoFieldsAR[] = 'OC_requireSubmissionUploadField';
}

// Notification array
$notifyAR = array(
	'OC_notifyAuthorSubmit'				=> 'Author makes a submission',
	'OC_notifyAuthorEdit'				=> 'Author updates (edits) submission',
	'OC_notifyAuthorEmailPapers'		=> 'Author requests own submission list emailed',
	'OC_notifyAuthorUpload'				=> 'Author uploads a file',
	'OC_notifyAuthorReset'				=> 'Author requests password reset',
	'OC_notifyAuthorWithdraw'			=> 'Author withdraws submission',
	'OC_notifyReviewerSignup'			=> 'Committee member signs up for account',
	'OC_notifyReviewerProfileUpdate'	=> 'Committee member updates profile',
	'OC_notifyReviewerReset'			=> 'Committee member resets password',
	'OC_notifyReviewerEmailUsername' 	=> 'Committee member requests username emailed'
);

// Submission?
$e = array();
if (isset($_POST['submit']) && ($_POST['submit'] == "Save Settings")) {
	// Check for valid submission
	if (OCC_INSTALL_COMPLETE && !validToken('chair')) {
		warn('Invalid submission', $hdr, $hdrfn);
	}
	// Check input
	if (!isset($_POST['OC_confName']) || !preg_match("/\w/", $_POST['OC_confName'])) {
		$e[] = 'Event Short Name must include at least one alphanumeric character';
	}
	if (!isset($_POST['OC_confNameFull']) || !preg_match("/\w/", $_POST['OC_confNameFull'])) {
		$e[] = 'Event Full Name must include at least one alphanumeric character';
	}
	if (!isset($_POST['OC_pcemail'])) {
		$e[] = 'Chair Email address invalid.';
	} elseif (preg_match("/,/", $_POST['OC_pcemail'])) {   // Multiple addresses
		$cmAR = explode(",", $_POST['OC_pcemail']);
		foreach ($cmAR as $cm) {
			$cm = trim($cm);
			if (!validEmail($cm)) {
				$e[] = 'Chair Email does not appear to be valid';
				break;
	 		}
    	}
	} elseif (!validEmail($_POST['OC_pcemail'])) {  // Single address
		$e[] = 'Chair Email does not appear to be valid';
	}
	if (!isset($_POST['OC_confirmmail'])) {
		$e[] = 'Notification Email address invalid.  Try setting it the same as the Chair Email';
	} elseif (preg_match("/,/", $_POST['OC_confirmmail'])) {   // Multiple addresses
		$cmAR = explode(",", $_POST['OC_confirmmail']);
		foreach ($cmAR as $cm) {
			$cm = trim($cm);
			if (!validEmail($cm)) {
				$e[] = 'Notification Email does not appear to be valid';
				break;
	 		}
    	}
	} elseif (!validEmail($_POST['OC_confirmmail'])) {  // Single address
		$e[] = 'Notification Email does not appear to be valid';
	}
	if (($_POST['OC_trackStudent'] != 0) && ($_POST['OC_trackStudent'] != 1)) {
		$e[] = 'Track Students value is invalid';
	}
	if (!isset($_POST['OC_abstractLength']) || !ctype_digit($_POST['OC_abstractLength'])) {
		$e[] = 'Abstract Length value is invalid';
	}
	if (!isset($_POST['OC_extar']) || count($_POST['OC_extar']) == 0) {
		$e[] = 'Select at least one file format';
	} else { // check formats are valid
		foreach ($_POST['OC_extar'] as $fmat) {
			if (!isset($OC_formatAR[$fmat])) {
				$e[] = 'Invalid format selected';
				continue;
			}
		}
	}

	$notifyKeysAR = array_keys($notifyAR);
	foreach ($notifyKeysAR as $nk) {
		if (!isset($_POST[$nk])) {
			$_POST[$nk] = 0;
		} elseif (!preg_match("/^[01]$/", $_POST[$nk])) {
			$e[] = 'Invalid notification selection';
			continue;
		}
	}
	foreach ($yesNoFieldsAR as $ynf) {
		if (!isset($_POST[$ynf]) || !isset($yesNoAR[$_POST[$ynf]])) {
			$e[] = 'Invalid option (' . safeHTMLstr($ynf) . ')';
		}
	}
	if (!isset($_POST['OC_timeZone']) || !in_array($_POST['OC_timeZone'], $OC_zoneAR)) {
		$e[] = 'Time Zone is invalid';
	}
	if (!isset($_POST['OC_locales']) || empty($_POST['OC_locales']) || !is_array($_POST['OC_locales'])) {
		$e[] = 'At least one language must be selected';
		$_POST['OC_locales'] = array();
	} else {
		if (!isset($_POST['OC_localeDefault']) || !isset($OC_languageAR[$_POST['OC_localeDefault']])) {
			$e[] = 'Default Language is invalid';
		} elseif (!in_array($_POST['OC_localeDefault'], $_POST['OC_locales'])) {
			$_POST['OC_locales'][] = $_POST['OC_localeDefault'];	// auto-select default language
		}
		foreach ($_POST['OC_locales'] as $locale) {
			if (!isset($OC_languageAR[$locale])) {
				$e[] = 'Invalid locale selected: ' . safeHTMLstr($locale);
			}
		}
	}
	if (empty($e)) {
		// Update form's OC_ fields
		$_POST['OC_extar'] = implode(',', $_POST['OC_extar']);
		$_POST['OC_locales'] = implode(',', $_POST['OC_locales']);
		foreach (array_keys($_POST) as $p) {
			if (preg_match("/^OC_[\w-]+$/", $p) && isset($OC_configAR[$p]) && ($OC_configAR[$p] != $_POST[$p])) {
				updateConfigSetting($p, $_POST[$p], 'OC');
				$OC_configAR[$p] = $_POST[$p];
			}
		}
		
		// if install, redirect
		if (isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
			header("Location: set_topics.php?install=1");
			exit;
		}
		
		print '<p class="note"><strong>Configuration sucessfully updated</strong></p>';
		
		// reset special vars to array
		$_POST['OC_extar'] = explode(',', $OC_configAR['OC_extar']);
		$_POST['OC_locales'] = explode(',', $OC_configAR['OC_locales']);
	}
} else { // not submit; init POST with config values
	$_POST = $OC_configAR;
	$_POST['OC_locales'] = explode(',', $OC_configAR['OC_locales']);
}

if ((!OCC_INSTALL_COMPLETE) && isset($_REQUEST['install']) && ($_REQUEST['install'] == 1)) {
	printHeader($hdr,$hdrfn);
	print '<p align="center"><strong>Step 3 of 5: Tailor Configuration Settings</strong></p>';
}

if (!empty($e)) {
	print '<div class="warn">Please correct the following:<br /><ul><li>' . implode('</li><li>',$e) . '</li></ul></div>';
}

print '
<form method="post" action="'.$_SERVER['PHP_SELF'].'" class="ocform occonfigform">
<input type="hidden" name="token" value="' . $token . '" />
';

if ((!OCC_INSTALL_COMPLETE) && isset($_REQUEST['install'])) {
    print '
<input type="hidden" name="install" value="' . safeHTMLstr($_REQUEST['install']) . '" />
';
}

print '
<fieldset>
<legend>Event</legend>
<div class="field"><label for="OC_confNameFull">Event Full Name:</label><input size="60" name="OC_confNameFull" id="OC_confNameFull" value="' . safeHTMLstr($_POST['OC_confNameFull']) . '"><div class="fieldnote note">Event name used on Web pages and in email messages</div></div>
<div class="field"><label for id="OC_confName">Event Short Name:</label><input size="60" name="OC_confName" id="OC_confName" value="' . safeHTMLstr($_POST['OC_confName']) . '"><div class="fieldnote note">Event abbreviated name, primarily used in email subject lines</div></div>
<div class="field"><label for id="OC_confURL">Event Web Address:</label><input size="60" name="OC_confURL" id="OC_confURL" value="' . safeHTMLstr($_POST['OC_confURL']) . '"><div class="fieldnote note">Full web address (including http:// ) for event web page</div></div>
<div class="field"><label for id="OC_headerImage">Header Image:</label><input size="60" name="OC_headerImage" id="OC_headerImage" value="' . safeHTMLstr($_POST['OC_headerImage']) . '"><div class="fieldnote note">Full web address (including http:// ) for image to display atop every page.  Leave blank to display event full name</div></div>
<div class="field"><label for="OC_homePageNotice">Home Page Notice:<br /><br /><span class="note">Notice appearing atop<br />OpenConf home page<br />(optional)</span></label><textarea name="OC_homePageNotice" rows="4" cols="50">' . safeHTMLstr($_POST['OC_homePageNotice']) . '</textarea></div>
</fieldset>

<fieldset>
<legend>Email &amp; Notification</legend>
<div class="field"><label for="OC_pcemail">Chair Email:</strong></label><input size="50" name="OC_pcemail" id="OC_pcemail" value="' . safeHTMLstr($_POST['OC_pcemail']) . '"><div class="fieldnote note">Used as the general contact email and in case of errors or other follow-up</div></div>
<div class="field"><label for="OC_confirmmail">Notification Email:</label><input size="50" name="OC_confirmmail" id="OC_confirmmail" value="' . safeHTMLstr($_POST['OC_confirmmail']) . '"><div class="fieldnote note">Receives a copy of confirmation emails sent to authors and committee members; see options below</div></div>

<label>Notify when:</label>
<div class="subfieldset"><fieldset class="checkbox">
';

foreach ($notifyAR as $nk => $nv) {
	print '<label><input type="checkbox" name="' . $nk . '" id="' . $nk . '" value="1" ';
	if ($_POST[$nk] == 1) { print 'checked '; }
	print '/> ' . safeHTMLstr($nv) . '</label><br />';
}

print '
</fieldset>
<p />
Include IP address in notifications?<fieldset class="radio">' . generateRadioOptions('OC_notifyIncludeIP', $yesNoAR, $_POST['OC_notifyIncludeIP']) . '</fieldset>
</div>

</fieldset>

<fieldset>
<legend>Reviewers</legend>
<div class="field"><label for="OC_keycode_reviewer">Sign Up Keycode:</label><input size="20" name="OC_keycode_reviewer" id="OC_keycode_reviewer" value="' . safeHTMLstr($_POST['OC_keycode_reviewer']) . '"><div class="fieldnote note">Keycode for signing up as a review committee member.</div></div>
<div class="field"><label for="OC_reviewerSignUpNotice">Sign Up Notice:<br /><br /><span class="note">Notice appearing atop<br />reviewer sign up page</span></label><textarea name="OC_reviewerSignUpNotice" rows="4" cols="50">' . safeHTMLstr($_POST['OC_reviewerSignUpNotice']) . '</textarea></div>

<label>Reviewer Permissions:</label>
<div class="subfieldset">
<div class="field">Allow reviewers to view all submissions?<fieldset class="radio">' . generateRadioOptions('OC_reviewerReadPapers', $yesNoAR, $_POST['OC_reviewerReadPapers']) . '</fieldset></div>
<div class="field">Allow reviewers to see others\' review of assigned submissions?<fieldset class="radio">' .generateRadioOptions('OC_reviewerSeeAssignedReviews', $yesNoAR, $_POST['OC_reviewerSeeAssignedReviews']) . '</fieldset></div>
<div class="field">Only allow reviewer to see reviews of assigned submissions if own is complete?<fieldset class="radio">' . generateRadioOptions('OC_reviewerCompleteBeforeSAR', $yesNoAR, $_POST['OC_reviewerCompleteBeforeSAR']) . '</fieldset></div>
<div class="field">Allow reviewer to see reviews of non-assigned submissions?<fieldset class="radio">' . generateRadioOptions('OC_reviewerSeeOtherReviews', $yesNoAR, $_POST['OC_reviewerSeeOtherReviews']) . '</fieldset></div>
<div class="field">Allow reviewers to see each other\'s information? (e.g., name, email)<fieldset class="radio">' . generateRadioOptions('OC_reviewerSeeOtherReviewers', $yesNoAR, $_POST['OC_reviewerSeeOtherReviewers']) . '</fieldset></div>
<div class="field">Allow reviewers to see authors (i.e., non-blind reviews)?<fieldset class="radio">' . generateRadioOptions('OC_reviewerSeeAuthors', $yesNoAR, $_POST['OC_reviewerSeeAuthors']) . '</fieldset></div>
</div>

<div class="field"><label for="OC_committeeFooter">Committee Page Notice:<br /><br /><span class="note">Notice appearing at the bottom of the main committee page</span></label><textarea name="OC_committeeFooter" rows="4" cols="50">' . safeHTMLstr($_POST['OC_committeeFooter']) . '</textarea></div>
</fieldset>

<fieldset>
<legend>Advocates (Program Committee)</legend>
<div class="field"><label for="OC_paperAdvocates">Use Advocates?</label><fieldset class="radio">' . generateRadioOptions('OC_paperAdvocates', $yesNoAR, $_POST['OC_paperAdvocates'], 1, 'onclick="oc_showHideDiv(\'OC_paperAdvocates1\', \'advocates\')"') . '</fieldset><div class="fieldnote note">Select whether to make use of Advocates</div></div>

<div id="advocates">
<div class="field"><label for="OC_keycode_program">Sign Up Keycode:</label><input size="20" name="OC_keycode_program" value="' . safeHTMLstr($_POST['OC_keycode_program']) . '"><div class="fieldnote note">Keycode for signing up as a program committee member.</div></div>
<div class="field"><label for="OC_programSignUpNotice">Sign Up Notice:<br /><br /><span class="note">Notice appearing atop<br />advocate sign up page</span></label><textarea name="OC_programSignUpNotice" rows="4" cols="50">' . safeHTMLstr($_POST['OC_programSignUpNotice']) . '</textarea></div>
<label>Advocate Permissions:</label>
<div class="subfieldset">
<div class="field">Allow advocates to view all submissions?<fieldset class="radio">' . generateRadioOptions('OC_advocateReadPapers', $yesNoAR, $_POST['OC_advocateReadPapers']) . '</fieldset></div>
<div class="field">Allow advocates to see reviews of non-assigned submissions?<fieldset class="radio">' . generateRadioOptions('OC_advocateSeeOtherReviews', $yesNoAR, $_POST['OC_advocateSeeOtherReviews']) . '</fieldset></div>
<div class="field">Allow advocates to see authors?<fieldset class="radio">' . generateRadioOptions('OC_advocateSeeAuthors', $yesNoAR, $_POST['OC_advocateSeeAuthors']) . '</fieldset></div>
<div class="note">NOTE: Reviewer permissions are evaluated before advocate\'s</div>
</div>

</fieldset>


<fieldset>
<legend>Submission</legend>

<div class="field"><label for="OC_paperSubNote">Submission Notice:<br /><br /><span class="note">Notice appearing atop<br />submission page</span></label><textarea name="OC_paperSubNote" rows="4" cols="50">' . safeHTMLstr($_POST['OC_paperSubNote']) . '</textarea></div>

<div class="field"><label for="OC_trackStudent">Track Students?</label><fieldset class="radio">' . generateRadioOptions('OC_trackStudent', $yesNoAR, $_POST['OC_trackStudent'], 1, 'onclick="oc_showHideDiv(\'OC_trackStudent1\', \'studNotice\')"') . '</fieldset></div>

<div class="field" id="studNotice"><label for="OC_studentNote">Student Note:<br /><br /><span class="note">Note displayed beneath<br />Student field</span></label><textarea name="OC_studentNote" rows="4" cols="50">' . safeHTMLstr($_POST['OC_studentNote']) . '</textarea></div>

<div class="field"><label for="OC_abstractLength">Abstract Length:</label><input name="OC_abstractLength" id="OC_abstractLength" size="5" value="' . varValue('OC_abstractLength', $_POST) . '" /> words<div class="fieldnote note">Enter 0 (zero) for no limit</div></div>
';

if ( ! oc_moduleActive('oc_aws') ) { // submission form file upload is not compatible with AWS
	print '
<div class="field"><label for="OC_includeSubmissionUploadField">Include File Upload Field?</label><fieldset class="radio">' . generateRadioOptions('OC_includeSubmissionUploadField', $yesNoAR, $_POST['OC_includeSubmissionUploadField']) . '</fieldset><div class="fieldnote note">Includes file upload field on submission page; overrides Include File Upload Link setting</div></div>

<div class="field"><label for="OC_requireSubmissionUploadField">Require File Upload?</label><fieldset class="radio">' . generateRadioOptions('OC_requireSubmissionUploadField', $yesNoAR, $_POST['OC_requireSubmissionUploadField']) . '</fieldset><div class="fieldnote note">Requires file to be uploaded at submission if Include File Upload Field enabled</div></div>
';
}

print '
<div class="field"><label for="OC_includeSubmissionUploadLink">Include File Upload Link?</label><fieldset class="radio">' . generateRadioOptions('OC_includeSubmissionUploadLink', $yesNoAR, $_POST['OC_includeSubmissionUploadLink']) . '</fieldset><div class="fieldnote note">Includes file upload link on submission confirmation page.' . (oc_moduleActive('oc_aws') ? '' : '  Applies only if Include File Upload Field is not enabled.<br />') . '  Note that Upload File status must also be set to open</div></div>

</fieldset>
';

if (oc_hookSet('set-config-fileupload')) {
	foreach ($GLOBALS['OC_hooksAR']['set-config-fileupload'] as $hook) {
		require_once $hook;
	}
} else {
	print '
<fieldset>
<legend>Files</legend>
<div class="field"><label for="OC_extar">File Formats:</label><select name="OC_extar[]" size="7" multiple>' . generateSelectOptions($OC_formatAR, $_POST['OC_extar'], TRUE, TRUE) . '</select></div>

<div class="field"><label for="OC_paperFldNote">File Note:<br /><br /><span class="note">Note displayed with<br />file upload field</span></label><textarea name="OC_paperFldNote" rows="4" cols="50">' . safeHTMLstr($_POST['OC_paperFldNote']) . '</textarea></div>
</fieldset>
';
}

print '
<fieldset>
<legend>Localization</legend>
<div class="note" style="margin-bottom: 2em;">The language options are currently experimental.  They allow the author pages to be viewed in one\'s native language.  For additional information, or to assist with translations, visit <a href="http://www.OpenConf.com/translate/" target="_blank">www.OpenConf.com/translate/</a>.' . (function_exists('gettext') ? '' : ' <strong>PHP must have gettext enabled.</strong>') . '</div>
<div class="field"><label for="OC_locales">Languages:</label><select name="OC_locales[]" multiple size="5">
';

foreach ($OC_languageAR as $locale => $localeAR) {
	print '<option value="' . safeHTMLstr($locale) . '"' . (in_array($locale, $_POST['OC_locales']) ? ' selected' : '') . '>' . safeHTMLstr($localeAR['language']) . '</option>';
}

print '
</select></div>

<div class="field"><label for="OC_localeDefault">Default Language:</label><select name="OC_localeDefault">
';

foreach ($OC_languageAR as $locale => $localeAR) {
	print '<option value="' . safeHTMLstr($locale) . '"' . (($locale == $_POST['OC_localeDefault']) ? ' selected' : '') . '>' . safeHTMLstr($localeAR['language']) . '</option>';
}

print '
</select></div>

<div class="field"><label for="OC_includeSubmissionUploadLink">Time Zone:</label><select name="OC_timeZone">
' . generateSelectOptions($OC_zoneAR, $_POST['OC_timeZone'], FALSE) . '
</select></div>

</fieldset>

<p><input type="submit" name="submit" value="Save Settings" class="submit" /></p>
</form>

<script language="javascript" type="text/javascript">
<!--
oc_showHideDiv("OC_paperAdvocates1","advocates");
oc_showHideDiv("OC_trackStudent1","studNotice");
// -->
</script>


';


printFooter();
?>
