<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

// Check personal info
oc_checkField('name_last', $OC_reviewerFieldAR, $qfields, $err);
oc_checkField('name_first', $OC_reviewerFieldAR, $qfields, $err);

if (isset($OC_reviewerFieldAR['email']) && oc_fieldEnabled('email', $GLOBALS['OC_reviewerFieldAR'])) {
	if (isset($_POST['email']) && !empty($_POST['email'])) {
		$_POST['email'] = trim($_POST['email']);
		if (!validEmail($_POST['email'])) {
			$err .= '<li>' . sprintf(oc_('%s field does not appear to be valid'), $GLOBALS['OC_reviewerFieldAR']['email']['short']) . '</li>';
		} else {
			if (preg_match("/signup\.php/", $_SERVER['PHP_SELF'])) {	// signup
				$eq = "SELECT `reviewerid` FROM `" . OCC_TABLE_REVIEWER . "` WHERE `email`='" . safeSQLstr(trim($_POST['email'])) . "'";
			} else { // profile update
				$eq = "SELECT `reviewerid` FROM `" . OCC_TABLE_REVIEWER . "` WHERE `email`='" . safeSQLstr(trim($_POST['email'])) . "' AND `reviewerid`!='" . safeSQLstr($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']) . "'";			
			}
			$er = ocsql_query($eq) or err("could not check email address");
			if (mysql_num_rows($er) != 0) {
				print '<p class="warn" style="text-align: center">' . sprintf(oc_('An account for the email address entered already exists.  Would you like to <a href="%1$s">Sign In</a> or <a href="%2$s">Recover Username</a>?'), 'signin.php', 'email_username.php') . '</p>';
				printFooter();
				exit;
			}
		}
		$qfields['email'] = "'" . safeSQLstr(trim($_POST['email'])) . "'";
	} elseif ( $GLOBALS['OC_reviewerFieldAR']['email']['required'] ) {
		$err .= '<li>' . sprintf(oc_('%s field is required'), $GLOBALS['OC_reviewerFieldAR']['email']['short']) . '</li>';
	} else {
		$qfields['email'] = "''";
	}
}

oc_checkField('organization', $OC_reviewerFieldAR, $qfields, $err);
oc_checkField('country', $OC_reviewerFieldAR, $qfields, $err, true);
oc_checkField('telephone', $OC_reviewerFieldAR, $qfields, $err);
oc_checkField('url', $OC_reviewerFieldAR, $qfields, $err);

// Check account
if (isset($OC_reviewerFieldAR['username']) && oc_fieldEnabled('username', $GLOBALS['OC_reviewerFieldAR'])) {
	if (!isset($_POST['username']) || !preg_match("/^[\w\.\-\@]{5,30}$/", trim($_POST['username']))) {
		//T: $1$d and $2$d = range of characters permitted (e.g., 5 and 30)
		$err .= '<li>' . sprintf(oc_('Username must be between %1$d and %2$d characters: letters, numbers, period, hyphen, @'), 5, 30) . '</li>';
	} elseif (preg_match("/signup\.php/", $_SERVER['PHP_SELF'])) {
		// check that user does not yet have an account; notify & bail if they do
		$uq = "SELECT `reviewerid` FROM `" . OCC_TABLE_REVIEWER . "` WHERE `username`='" . safeSQLstr(strtolower(trim($_POST['username']))) . "'";
		$ur = ocsql_query($uq) or err("could not check username");
		if (mysql_num_rows($ur) != 0) {
			$err .= '<li>' . sprintf(oc_('Username is already taken; select a different username (or <a href="%s">Sign In</a> if you already registered)'), 'signin.php') . '</li>';
		} else {
			$qfields['username'] = "'" . safeSQLstr(strtolower(trim($_POST['username']))) . "'";
		}
	}
}
// Check password if either field is not empty or it's an original signup
if ( (isset($_POST['password1']) && !empty($_POST['password1']))			// fld pwd1 set
		|| (isset($_POST['password2']) && !empty($_POST['password2'])) 		// fld pwd 2 set
		|| ( ! isset($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']) )		// profile update
) {
	if (!isset($_POST['password1']) || !isset($_POST['password2']) || empty($_POST['password1'])) {
		$err .= '<li>' . oc_('Password must be entered twice') . '</li>';
	} elseif ($_POST['password1'] != $_POST['password2']) {
		$err .= '<li>' . oc_('Passwords entered do not match') . '</li>';
	} elseif ( ! preg_match("/^.{8}/",$_POST['password1'])) {
		//T: %d = number of characters
		$err .= '<li>' . sprintf(oc_('Password must be at least %d characters'), 8) . '</li>';
	} else {
		$qfields['password'] = "'" . hashPassword($_POST['password1']) . "'";
	}
}

// Check topics
if (isset($OC_reviewerFieldAR['topics']) && oc_fieldEnabled('topics', $GLOBALS['OC_reviewerFieldAR'])) {
	if (!isset($_POST['topics']) || empty($_POST['topics'])) {
		$err .= '<li>' . sprintf(oc_('%s field is required'), $GLOBALS['OC_reviewerFieldAR']['topics']['short']) . '</li>';
	} else {
		if (is_array($_POST['topics'])) {
			foreach ($_POST['topics'] as $tid) {
				if ( !ctype_digit($tid) || !isset($topicAR[$tid]) ) {
					$err .= '<li>' . sprintf(oc_('%1$s field value is invalid: %2$s'), $GLOBALS['OC_reviewerFieldAR']['topics']['short'], safeHTMLstr($tid)) . '</li>';
				} else {
					$tfields[] = $tid;
				}
			}
		} else {
			if ( !ctype_digit($_POST['topics']) || !isset($topicAR[$_POST['topics']]) ) {
					//T: %1$s = topic field short name; %2$s = invalid field value
				$err .= '<li>' . sprintf(oc_('%1$s field value is invalid: %2$s'), $GLOBALS['OC_submissionFieldAR']['topics']['short'], safeHTMLstr($_POST['topics'])) . '</li>';
			} else {
				$tfields[] = $_POST['topics'];
			}
		}
	}
}

// Check comments
oc_checkField('comments', $OC_reviewerFieldAR, $qfields, $err);

// hook
if (oc_hookSet('committee-profile-validate')) {
	foreach ($GLOBALS['OC_hooksAR']['committee-profile-validate'] as $hook) {
		require_once $hook;
	}
}

