<?php
// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once OCC_COUNTRY_FILE;

// Get topics
$topq = "SELECT * FROM `" . OCC_TABLE_TOPIC . "`";
if ($OC_configAR['OC_topicDisplayAlpha']) { 
	$topq .= " ORDER BY `topicname`";
}
$topr = ocsql_query($topq) or err('unable to retrieve topics');
if (($tnum = mysql_num_rows($topr)) < 1) {
	warn(oc_('We are still waiting for the Chair to finalize the list of topics.  Please check back later.'), 'Committee Sign Up', 3);
} else {
	$topicAR = array();
	while ($topl = mysql_fetch_assoc($topr)) {
		$topicAR[$topl['topicid']] = $topl['topicname'];
	}
}

// See include-forms.inc for syntax format

$OC_reviewerFieldAR = array();
$OC_reviewerFieldSetAR = array();

// Personal Info
$OC_reviewerFieldAR['name_first'] = array(
	'name' => oc_('First/Given Name'),
	'short' => oc_('First Name'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 60,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldAR['name_last'] = array(
	'name' => oc_('Last/Family Name'),
	'short' => oc_('Last Name'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 40,
	'required' => TRUE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldAR['email'] = array(
	'name' => oc_('Email'),
	'short' => oc_('Email'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 100,
	'usekey' => FALSE,
	'required' => TRUE,
	'values' => ''
);

$OC_reviewerFieldAR['organization'] = array(
	'name' => oc_('Organization'),
	'short' => oc_('Organization'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 250,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldAR['country'] = array(
	'name' => oc_('Country'),
	'short' => oc_('Country'),
	'note' => '',
	'type' => 'select',
	'blank' => true,
	'required' => FALSE,
	'usekey' => TRUE,
	'values' => $GLOBALS['OC_countryAR']
);

$OC_reviewerFieldAR['telephone'] = array(
	'name' => oc_('Telephone'),
	'short' => oc_('Telephone'),
	'note' => '',
	'type' => 'text',
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldAR['url'] = array(
	'name' => oc_('Web Address'),
	'short' => oc_('Web Address'),
	'note' => oc_('include http://'),
	'type' => 'text',
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldSetAR['fs_personal'] = array(
	'fieldset' => oc_('Personal Info'),
	'note' => '',
	'fields' => array('name_first', 'name_last', 'email', 'organization', 'country', 'telephone', 'url')
);

// Topics
if (count($topicAR) > 1) {
	$OC_reviewerFieldAR['topics'] = array(
		'name' => oc_('Topic Areas'),
		'short' => oc_('Topic(s)'),
		'note' => '',
		'type' => 'checkbox',
		'usekey' => TRUE,
		'required' => TRUE,
		'values' => $topicAR
	);
	
	$OC_reviewerFieldSetAR['fs_topics'] = array(
		'fieldset' => oc_('Topic Areas'),
		'note' => oc_('To help match submissions to reviewers, please select one or more areas that you are most comfortable reviewing.'),
		'fields' => array('topics')
	);
} else { // single topic
	$OC_reviewerFieldAR['topics'] = array(
		'name' => oc_('Topic Area'),
		'short' => oc_('Topic'),
		'note' => '',
		'type' => 'plain',
		'required' => TRUE,
		'values' => safeHTMLstr(current($topicAR)) . '<input type="hidden" name="topics[]" value="' . key($topicAR) . '" />'
	);
	
	$OC_reviewerFieldSetAR['fs_topics'] = array(
		'fieldset' => oc_('Topic Areas'),
		'note' => '',
		'fields' => array('topics')
	);
}

// Comments
$OC_reviewerFieldAR['comments'] = array(
	'name' => oc_('Comments to Chair'),
	'short' => oc_('Comments'),
	'note' => '',
	'type' => 'textarea',
	'size' => 5,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_reviewerFieldSetAR['fs_comments'] = array(
	'fieldset' => oc_('Comments'),
	'note' => '',
	'fields' => array('comments')
);

// Account
$OC_reviewerFieldAR['username'] = array(
	'name' => oc_('Username'),
	'short' => oc_('Username'),
	//T: %1$d-%2$d = range of letters allowed (e.g., 5-30)
	'note' => sprintf(oc_('%1$d-%2$d letters, numbers, period (.), hyphen (-), or @'), 5, 30),
	'type' => 'text',
	'usekey' => FALSE,
	'required' => TRUE,	// always true
	'values' => ''
);
$OC_reviewerFieldAR['password1'] = array(
	'name' => oc_('Password'),
	'short' => oc_('Password'),
	'note' => sprintf(oc_('%d+ characters'), 8),
	'type' => 'password',
	'usekey' => FALSE,
	'required' => TRUE,	// always true
	'values' => ''
);

$OC_reviewerFieldAR['password2'] = array(
	'name' => oc_('Re-enter Password'),
	'short' => oc_('Confirm'),
	'note' => '',
	'type' => 'password',
	'usekey' => FALSE,
	'required' => TRUE,	// always true
	'values' => ''
);

$OC_reviewerFieldSetAR['fs_passwords'] = array(
	'fieldset' => oc_('Account'),
	'note' => '',
	'fields' => array('username', 'password1', 'password2')
);

if (oc_hookSet('committee-profile-inc')) {
	foreach ($GLOBALS['OC_hooksAR']['committee-profile-inc'] as $v) {
		require_once $v;
	}
}

