<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";
require_once OCC_REVIEW_INC_FILE;

//T: File = table header used for file column
$fileTableHeader = '<th>' . oc_('File') . '</th>'; // table header used for file column
$formatField = '`format`'; // paper table format field

beginSession();

printHeader(oc_('Committee Member'), 2);

print "<dl>\n";

$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);

if (oc_hookSet('committee-menu-preprocess')) {
	foreach ($OC_hooksAR['committee-menu-preprocess'] as $v) {
		require_once $v;
	}
}

// Can reviewers still sign-in?
if ($OC_statusAR['OC_rev_signin_open']) {
	$extraFields = '';
	
	if ($OC_configAR['OC_reviewerReadPapers'] || $OC_configAR['OC_reviewerSeeAssignedReviews'] || $OC_configAR['OC_reviewerSeeOtherReviews'] || (($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_configAR['OC_advocateSeeOtherReviews'])) {
		print '<dt>&#8226; <strong><a href="list_papers.php">' . oc_('View Submissions') . '</a></strong><p /></dt>';
	}
	
	if (oc_hookSet('committee-menu-prereview')) {
		foreach ($OC_hooksAR['committee-menu-prereview'] as $v) {
			print '<dt>&#8226; ' . $v . '<p /></dt>';
		}
	}
	if (oc_hookSet('committee-menu-pc-prereview') && ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
		foreach ($OC_hooksAR['committee-menu-pc-prereview'] as $v) {
			print '<dt>&#8226; ' . $v . '<p /></dt>';
		}
	}
	
	if (oc_moduleActive('oc_subtype')) {
		$extraFields .= ", `module_oc_subtype_type`";
	}

	print '
<dt>&#8226; <strong>' . oc_('Submissions to Review:') . '</strong></dt>
<dd><br />
';
	$q = "SELECT `" . OCC_TABLE_PAPERREVIEWER . "`.`paperid`, " . $formatField . ", `title`, `completed`" . $extraFields . " FROM `" . OCC_TABLE_PAPERREVIEWER . "`, `" . OCC_TABLE_PAPER . "` WHERE `reviewerid`='" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'] . "' AND `" . OCC_TABLE_PAPERREVIEWER . "`.`paperid`=`" . OCC_TABLE_PAPER . "`.`paperid`";
	$r = ocsql_query($q) or err("Unable to retrieve submissions for review");
	if (mysql_num_rows($r) == 0) { 
		print '<span class="err">' . oc_('You do not have any submissions to review.') . '</span><p>';
	} else {
		print '<table border="0" cellspacing="0" cellpadding="0"><tr><td><em>' . oc_('Legend:') . '</em> &nbsp; &nbsp; &nbsp; </td><td bgcolor="#66ff66"> &nbsp;o&nbsp; </td><td> &nbsp; <em>' . oc_('Review completed') . '</em> &nbsp; &nbsp; &nbsp; </td><td bgcolor="#ff6666"> &nbsp;x&nbsp; </td><td> &nbsp; <em>' . oc_('Review not yet completed') . '</em></td></tr></table><p>';
		print '<table border="0" cellspacing="1" cellpadding="3"><tr class="rowheader"><th>&nbsp;</th><th>' . oc_('Title - click for review form') . '</th><th>' . oc_('Abstract') . '</th>';
		if (oc_moduleActive('oc_subtype')) {
			//T: Type = Submission Type (e.g., paper, poster)
			print '<th>' . oc_('Type') . '</th>';
		}
		print $fileTableHeader . '</tr>';
		$row = 1;
		while ($p = mysql_fetch_array($r)) {
			// Skip if in conflict
			if (in_array($p['paperid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) { continue; }

			if ($p['completed'] == "T") { $color = "#66ff66"; $symbol = "o"; }
			else { $color = "#ff6666"; $symbol = "x"; }
			print '<tr class="row' . $row . '"><td valign="top" bgcolor="' . $color.'">&nbsp;' . $symbol . '&nbsp;</td><td valign="top"><a href="review.php?pid=' . $p['paperid'] . '" alt="' . sprintf(oc_('review form for submission ID %d'), $p['paperid']) . '">' . $p['paperid'] . ' - ' .  safeHTMLstr($p['title']) . '</a></td><td align="center"><a href="show_abstract.php?pid=' . $p['paperid'] . '"><img src="../images/document-sm.gif" border="0" alt="' . oc_('view abstract') . '" title="' . oc_('view abstract') . '" width="13" height="16" /></a></td>';
			if (oc_moduleActive('oc_subtype')) {
				print '<td>' . varValue('module_oc_subtype_type', $p, '&nbsp;', true) . '</td>';
			}
			print oc_printFileCells($p) . "</tr>\n";
			$row = $rowAR[$row];
		}
		print "</table>\n";
		print '<p><br />' . oc_('<em>Tip:</em> To download a file instead of opening it, right-click on the file icon and select <em>Save ...</em>') . "</p>\n"; 
		print '<p>' . sprintf(oc_('A <a href="%s" target="_blank">blank review form</a> (that opens in a separate window) is available for you to print out if you prefer writing it out before typing it in.'), 'review.php?pid=blank') . '</p>';
	}
	print '</dd>';
}

if (($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
	$extraFields = '';

	if (! $OC_statusAR['OC_rev_signin_open']) {
		if ($OC_configAR['OC_advocateReadPapers'] || $OC_configAR['OC_advocateSeeOtherReviews']) {
			print '<dt>&#8226; <strong><a href="list_papers.php">' . oc_('View Submissions') . '</a></strong><p /></dt>';
		}
		if (oc_hookSet('committee-menu-prereview')) {
			foreach ($OC_hooksAR['committee-menu-prereview'] as $v) {
				print '<dt>&#8226; ' . $v . '<p /></dt>';
			}
		}
		if (oc_hookSet('committee-menu-pc-prereview') && ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") && $OC_statusAR['OC_pc_signin_open']) {
			foreach ($OC_hooksAR['committee-menu-pc-prereview'] as $v) {
				print '<dt>&#8226; ' . $v . '<p /></dt>';
			}
		}
	}
    if ($OC_configAR['OC_paperAdvocates']) {
		if (oc_moduleActive('oc_subtype')) {
			$extraFields .= ", `module_oc_subtype_type`";
		}
	
		print '
<dt>&#8226; <strong>' . oc_('Submissions to Advocate:') . '</strong></dt>
<dd><br />
';
		$q = "SELECT `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`, `" . OCC_TABLE_PAPERADVOCATE . "`.`adv_recommendation`, `" . OCC_TABLE_PAPERREVIEWER . "`.`reviewerid`, " . $formatField . ", `title`, AVG(`recommendation`) AS `paperavg`" . $extraFields . " FROM (`" . OCC_TABLE_PAPERADVOCATE . "`, `" . OCC_TABLE_PAPER . "`) LEFT JOIN `" . OCC_TABLE_PAPERREVIEWER . "` ON `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`=`" . OCC_TABLE_PAPERREVIEWER . "`.`paperid` WHERE `" . OCC_TABLE_PAPERADVOCATE . "`.`advocateid`='".$_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']."' AND `" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`=`" . OCC_TABLE_PAPER . "`.`paperid` GROUP BY `paperid`";
		$r = ocsql_query($q) or err("Unable to retrieve submissions for advocating<p>");
		if (mysql_num_rows($r) == 0) { 
			print '<span class="err">' . oc_('You do not have any submissions to advocate.') . '</span><p>';
		} else {
			print '<table border="1" cellspacing="0" cellpadding="3">';
			//T: Recomm. = Recommendation (e.g., Accept, Reject) [abbreviate if possible]; Score = Average reviews score
			print '<table border="0" cellspacing="1" cellpadding="3"><tr class="rowheader"><th>' . oc_('Recomm.') . '</th><th>' . oc_('Score') . '</th><th>' . oc_('Title - click for recommendation form') . '</th><th>' . oc_('Abstract') . '</th>';
			if (oc_moduleActive('oc_subtype')) {
				//T: Type = Submission Type (e.g., paper, poster)
				print '<th>' . oc_('Type') . '</th>';
			}
			print $fileTableHeader . '</tr>';
			$row = 1;
			while ($p = mysql_fetch_array($r)) {
				// Skip if in conflict
				if (in_array($p['paperid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) { continue; }
				print '<tr class="row' . $row . '"><td valign="top" align="center" style="color: #555; ' . (!empty($p['adv_recommendation']) ? ('background-color: #' . $OC_acceptanceColorAR[$p['adv_recommendation']]) : '') . '">'. safeHTMLstr($p['adv_recommendation']) . '</td><td valign="top" align="center">' . number_format($p['paperavg'],2).'</td><td valign="top"><a href="advocate.php?pid='.$p['paperid'].'" title="' . sprintf(oc_('see reviews and make recommendation for submission ID %d'), $p['paperid']) . '">' . $p['paperid'] . ' - ' .  safeHTMLstr($p['title']) . '</a></td><td align="center"><a href="show_abstract.php?pid=' . $p['paperid'] . '"><img src="../images/document-sm.gif" border="0" alt="' . oc_('view abstract') . '" title="' . oc_('view abstract') . '" width="13" height="16" /></a></td>';
				if (oc_moduleActive('oc_subtype')) {
					print '<td>' . varValue('module_oc_subtype_type', $p, '&nbsp;', true) . '</td>';
				}
				print oc_printFileCells($p) . "</tr>\n";
				$row = $rowAR[$row];
			}
			print "</table>\n";
		}
		print '</dd>';
	}
}
print "</dl>\n";

if (!empty($OC_configAR['OC_committeeFooter'])) {
	print '<p /><hr /><p />' . nl2br($OC_configAR['OC_committeeFooter']);
}

printFooter();

?>
