<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginSession();

printHeader(oc_('Show Abstract'), 2);

if (!preg_match("/^\d+$/",$_REQUEST['pid'])) {
	warn(oc_('Submission ID is invalid.'));
}

$pid = $_REQUEST['pid'];

$displayAuthorFields = array('name', 'organization', 'country');
$displaySubmissionFields = array('abstract');
$showReferenceSites = true;

// Check for conflict
$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
if (in_array($pid . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) {
	warn(oc_('You appear to have a conflict with this submission'));
}

$ok = 0;
$blind = true;
// Check that reviewer has permission
if ($OC_configAR['OC_reviewerReadPapers']) {
	$ok = 1;
} else {    // make sure reviewer is assigned
	$q = "SELECT `paperid` FROM `" . OCC_TABLE_PAPERREVIEWER . "` WHERE `paperid`=" . $pid . " AND `reviewerid`=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
	$r = ocsql_query($q) or err("Unable to check reviewer permissions " . mysql_errno());
	if (mysql_num_rows($r) == 1) {
		$ok = 1;
	}
}
if ($OC_configAR['OC_reviewerSeeAuthors']) {
	$blind = false;
}
// If not ok, check if advocate & has permission
if ($_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") {
	if ( ! $ok ) {
		if ($OC_configAR['OC_advocateReadPapers']) {
			$ok = 1;
		} else { // make sure advocate is assigned
			$q = "SELECT `paperid` FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `paperid`=" . $pid . " AND `advocateid`=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
			$r = ocsql_query($q) or err("Unable to check advocate permissions " . mysql_errno());
			if (mysql_num_rows($r) == 1) {
				$ok = 1;
			}
		}
	}
	if ( $blind && $OC_configAR['OC_advocateSeeAuthors'] ) {
		$blind = false;
	}
}
// If still not ok, show error
if (!$ok) {
	warn(oc_('You do not have permission to retrieve this submission'));
}

require_once OCC_FORM_INC_FILE;
require_once OCC_SUBMISSION_INC_FILE;

if (oc_hookSet('committee-show-abstract-preprocess')) {
	foreach ($GLOBALS['OC_hooksAR']['committee-show-abstract-preprocess'] as $v) {
		require_once $v;
	}
}

// Get abstract
$q = "SELECT * FROM `" . OCC_TABLE_PAPER . "` WHERE paperid='" . $pid . "'";
$r = ocsql_query($q) or err("Unable to retrieve abstract");
if (mysql_num_rows($r) != 1) {
	warn(sprintf(oc_('Submission ID %d was not found'), $pid));
}
$l = mysql_fetch_array($r);
print '
<p><strong>' . oc_('Submission ID') . ':</strong> ' . $pid . '</p>

<p><strong>' . oc_('Title') . ':</strong></p>

<p>' . safeHTMLstr($l['title']);

if ( ! $blind && $showReferenceSites) {
	print ' &nbsp; <span style="white-space: none">[ 
<a href="http://citeseerx.ist.psu.edu/search?q=title' . urlencode(':("' . $l['title'] . '"') . ')" target="_blank">CiteSeer</a> | 
<a href="http://scholar.google.com/scholar?q=intitle' . urlencode(':"' . $l['title'] . '"') . '" target="_blank">Google Scholar</a> | 
<a href="http://www.scirus.com/srsapp/search?q=title' . urlencode(':"' . $l['title'] . '"') . '" target="_blank">Scirus</a>
 ]</span>';
}
 
print '</p>';

if (! $blind) { // show author info
	$aq = "SELECT *, CONCAT_WS(' ', `name_first`, `name_last`) AS `name` FROM `" . OCC_TABLE_AUTHOR . "` WHERE `paperid`=" . $pid . " ORDER BY `position`";
	$ar = ocsql_query($aq) or err("Unable to retrieve authors");
	print '<p><strong>' . oc_('Author(s)') . ':</strong></p>';
	while ($al = mysql_fetch_assoc($ar)) {
		foreach ($displayAuthorFields as $f) {
			if (empty($al[$f])) { continue; }
			if ($f == 'name') {
				print safeHTMLstr($al['name']);
				if ($showReferenceSites) {
					print ' &nbsp; <span style="white-space: none">[ 
<a href="http://citeseerx.ist.psu.edu/search?q=' . urlencode('"' . $al['name'] . '"') . '&t=auth" target="_blank">CiteSeer</a> | 
<a href="http://scholar.google.com/scholar?q=author' . urlencode(':"' . $al['name'] . '"') . '" target="_blank">Google Scholar</a> | 
<a href="http://www.scirus.com/srsapp/search?q=author' . urlencode(':"' . $al['name'] . '"') . '" target="_blank">Scirus</a>
]</span>';
				}
			} else {
				print safeHTMLstr(oc_getFieldValue($OC_submissionFieldAR, $al, $f));
			}
			print '<br />';
		}
		print '</p>';
	}
}

foreach ($displaySubmissionFields as $f) {
	print '<p><strong>' . $OC_submissionFieldAR[$f]['short'] . ':</strong></p>' . "\n" . nl2br(safeHTMLstr($l[$f]));
}

if (oc_hookSet('committee-show-abstract')) {
	foreach ($GLOBALS['OC_hooksAR']['committee-show-abstract'] as $v) {
		require_once $v;
	}
}

printFooter();

?>
